program main_windows;
uses
math,sysutils,sdl2,sdl2_image,sdl2_mixer,sdl2_ttf;

{$MODE Delphi}
var
   window:PSDL_Window;
   render:PPSDL_Renderer;
   loopGame:boolean;
   event:TSDL_Event ;

   image:PSDL_Texture;
   fnttexture:PSDL_Texture;

   font:PTTF_Font;

       GSeed,FPSCount,lastFPSCount : Integer;            // Counter for FPS
     _ms_prev,_last,_time,_gameTime:integer;
     passedTime, elapsed,rate,maxElapsed:single;




     function GetDelta: Single;
     begin
       Result := elapsed;
     end;

     function GetFPS: Integer;
     begin
      Result :=max( lastFPSCount,FPSCount);
     end;

     function GetTime: Single;
     begin
       Result := SDL_GetTicks();
     end;
     function TimerUpdate: Boolean;
     var
         finished : Boolean;
     begin
           _time := SDL_GetTicks();
     			 elapsed := (_time - _last) / 1000;
     			if (elapsed > maxElapsed) then elapsed := maxElapsed;
     			elapsed :=elapsed* rate;
     			_last := _time;
           inc(FPSCount);
     			if( _time - 1000 > _ms_prev ) then
           begin
           _ms_prev := _time;
           lastFPSCount:=FPSCount;
           FPSCount:=0;
           end;
       Result := True;
     end;

procedure Draw(tex:PSDL_Texture;x,y,w,h:integer);
var
    srcrect: TSDL_Rect;
begin
srcrect.x:=x;
srcrect.y:=y;
srcrect.w:=w;
srcrect.h:=h;

SDL_RenderCopy(render, tex,nil,@srcrect);
end;

procedure RenderText(txt:string;x,y,r,g,b:integer);
var
   surf:   PSDL_Surface;
   color:TSDL_Color;
   srcrect: TSDL_Rect;
begin
srcrect.x:=x;
srcrect.y:=y;
color.r:=r;
color.g:=g;
color.b:=b;
surf := TTF_RenderText_Blended(font,pchar(txt), color);
srcrect.w:=surf.w;
srcrect.h:=surf.h;
fnttexture := SDL_CreateTextureFromSurface(render, surf);
SDL_RenderCopy(render, fnttexture,nil,@srcrect);
SDL_DestroyTexture(fnttexture);
SDL_FreeSurface(surf);
end;

begin

  SDL_Init( SDL_INIT_EVERYTHING ) ;
  SDL_CreateWindowAndRenderer(320,480, SDL_RENDERER_ACCELERATED or SDL_RENDERER_PRESENTVSYNC,@window,@render);

   TTF_Init();


font := TTF_OpenFont('data/pf_ronda_seven.ttf',18);


    image:= IMG_LoadTexture(render,'data/SDL_logo.png');




       loopGame:=true;
       while loopGame do
       begin

         while SDL_PollEvent( @Event ) > 0 do
          begin
            case Event.key.type_ of
              SDL_QUITEV :
                begin

                  loopGame := false;
                  exit;

                end;
                 SDL_WINDOWEVENT:
                 begin
                   case event.window.event of
                         SDL_WINDOWEVENT_FOCUS_GAINED:
                         begin
                         end;
                         SDL_WINDOWEVENT_FOCUS_LOST:
                         begin
                            end;
                   end;
                 end;
              SDL_KeyDown :
              begin
                case event.key.keysym.scancode of
                 SDL_SCANCODE_ESCAPE:
                 begin
                         loopGame := false;
                  exit;

                   end;
                 end;
               end;
               SDL_MOUSEMOTION:
                begin
                end;
                SDL_FINGERDOWN:
                begin
                end;
                SDL_FINGERUP:
                begin
                end;
                SDL_FINGERMOTION:
                begin
                end;
            end;
          end;
        TimerUpdate();
         SDL_RenderClear(render);
         Draw(image,0,80,199,99);
         RenderText('SDL ON ANDROID',100,240-55,255,0,0);
         RenderText('FPS:'+inttostr(GetFPS),20,20,255,0,255);
         SDL_RenderPresent(Render);

       end;

  TTF_CloseFont(font);
  TTF_Quit();
  SDL_DestroyTexture(image);
  SDL_DestroyTexture(fnttexture);
  SDL_DestroyRenderer(render);
  SDL_DestroyWindow(window);
  SDL_Quit();




end.

